'
'   Copyright 2008   Radical Eye Software
'
'   See end of file for terms of use.
'
' Modified by Andy Lindsay for use with the
' Parallax Serial Terminal.

' sdrw_test for PST.spin  

CON
   
  _clkmode = xtal1 + pll16x         ' Crystal and PLL settings.
  _xinfreq = 5_000_000              ' 5 MHz crystal x 16 = 80 MHz

OBJ

  pst   : "Parallax Serial Terminal"  ' Serial communication object
  sdfat : "fsrw"
  
VAR

   byte tbuf[20]
   
PUB go | x

  pst.Start(115200)                 ' Start Parallax Serial Terminal
   x := \start
   pst.Str(string("Returned from start", pst#NL))
   pst.Dec(x)
   pst.NewLine
   
PUB start | r, sta, bytes

   pst.Str(string("Mounting.", pst#NL))        
   sdfat.mount(0)
   pst.Str(string("Mounted.", pst#NL))
   pst.Str(string("Dir: ", pst#NL))
   sdfat.opendir
   repeat while 0 == sdfat.nextfile(@tbuf)
      pst.Str(@tbuf)
      pst.NewLine
   pst.Str(string("That's the dir", pst#NL))
   pst.NewLine
   r := sdfat.popen(string("newfilex.txt"), "w")
   pst.Str(string("Opening returned "))
   pst.Dec(r)
   pst.NewLine
   sta := cnt
   bytes := 0
   repeat 3
      repeat 39
         sdfat.pputc("R")
      sdfat.pputc(pst#NL)
   sdfat.pclose
   pst.Str(string("Wrote file.", pst#NL))
   r := sdfat.popen(string("newfilexr.txt"), "r")
   pst.Str(string("Opening returned "))
   pst.Dec(r)
   pst.NewLine
   repeat
      r := sdfat.pgetc
      if r < 0
         quit
      pst.Char(r)
   pst.Str(string("That's, all, folks! 3", pst#NL))
   
{{
'  Permission is hereby granted, free of charge, to any person obtaining
'  a copy of this software and associated documentation files
'  (the "Software"), to deal in the Software without restriction,
'  including without limitation the rights to use, copy, modify, merge,
'  publish, distribute, sublicense, and/or sell copies of the Software,
'  and to permit persons to whom the Software is furnished to do so,
'  subject to the following conditions:
'
'  The above copyright notice and this permission notice shall be included
'  in all copies or substantial portions of the Software.
'
'  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
'  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}}